import { Seq } from "lazily-async";
export declare abstract class PipelineItem {
    previousItem?: PipelineItem;
    name?: string;
    constructor(previousItem?: PipelineItem, name?: string);
    abstract clone(name: string): PipelineItem;
}
export declare class PipelineValue extends PipelineItem {
    value: any;
    constructor(value: any, previousItem?: PipelineItem, name?: string);
    clone(name: string): PipelineValue;
}
export declare class PipelineError extends PipelineItem {
    message: string;
    error: any;
    constructor(message: string, error: any, previousItem?: PipelineItem, name?: string);
    clone(name: string): PipelineError;
}
export declare type BashoLogFn = (msg: string) => void;
export declare type BashoEvaluationResult = {
    mustPrint: boolean;
    result: Seq<PipelineItem>;
};
export declare function evaluate(args: Array<string>, pipedValues?: Array<string>, mustPrint?: boolean, onLog?: BashoLogFn, onWrite?: BashoLogFn): Promise<BashoEvaluationResult>;
